#--
################################################################################
#                      Copyright (C) 2011 Travis Herrick                       #
################################################################################
#                                                                              #
#                                 \v^V,^!v\^/                                  #
#                                 ~%       %~                                  #
#                                 {  _   _  }                                  #
#                                 (  *   -  )                                  #
#                                 |    /    |                                  #
#                                  \   _,  /                                   #
#                                   \__.__/                                    #
#                                                                              #
################################################################################
# This program is free software: you can redistribute it                       #
# and/or modify it under the terms of the GNU Lesser General Public License    #
# as published by the Free Software Foundation,                                #
# either version 3 of the License, or (at your option) any later version.      #
################################################################################
# This program is distributed in the hope that it will be useful,              #
# but WITHOUT ANY WARRANTY;                                                    #
# without even the implied warranty of MERCHANTABILITY                         #
# or FITNESS FOR A PARTICULAR PURPOSE.                                         #
# See the GNU Lesser General Public License for more details.                  #
#                                                                              #
# You should have received a copy of the GNU Lesser General Public License     #
# along with this program.  If not, see <http://www.gnu.org/licenses/>.        #
################################################################################
#++

require_relative '../helper'

class ShellResultTest < Test::Unit::TestCase
  def setup
    @obj = @class.new('Std Out', 'Std Err')
  end

  def test_readonly_attributes
    assert_raise(NoMethodError) { @obj.out = 'blah' }
    assert_raise(NoMethodError) { @obj.err = 'blah' }
  end

  def test_output_text
    assert_equal 'Std Out', @obj.out
  end

  def test_error_text
    assert_equal 'Std Err', @obj.err
  end

  def test_success
    result = @class.new('output', nil)
    assert_equal true, result.success?
    result = @class.new('output', '')
    assert_equal true, result.success?
    result = @class.new('output', '  ')
    assert_equal false, result.success?
  end

  def test_to_string
    assert_equal "Std Out\nStd Err", @obj.to_s
  end
end
